<?php
// Require the initialisation file
require_once '../../init.php';

// Required files
require_once MAX_PATH.'/lib/OA/Admin/Option.php';
require_once MAX_PATH.'/lib/OA/Admin/Settings.php';
require_once MAX_PATH.'/lib/max/Plugin/Translation.php';
require_once MAX_PATH.'/www/admin/config.php';
require_once MAX_PATH.'/lib/OA/Creative/File.php';
require_once MAX_PATH.'/lib/max/Plugin/Translation.php';

// Required files
require_once MAX_PATH.'/lib/OA/Dal.php';
require_once MAX_PATH.'/lib/max/other/common.php';
require_once MAX_PATH.'/lib/max/other/html.php';
require_once MAX_PATH.'/lib/OA/Admin/UI/component/Form.php';
require_once MAX_PATH.'/lib/max/Admin_DA.php';

if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'pgsql')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/pgsql.php';
}
else if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'mysqli')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/mysqli.php';
}

// Security check
OA_Permission::enforceAccount(OA_ACCOUNT_ADMIN);

$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];

// Create a new option object for displaying the setting's page's HTML form


$oOptions = new OA_Admin_Option('settings');

$prefSection = "adminconfiguration";

$setPref = $oOptions->getSettingsPreferences($prefSection);

$title = $setPref[$prefSection]['name'];

// Display the settings page's header and sections
$oHeaderModel = new OA_Admin_UI_Model_PageHeaderModel($title);
phpAds_PageHeader('account-settings-index', $oHeaderModel);




if (isset($_POST['submitok']) && $_POST['submitok'] == 'true')
{

    $sdk_android = $_POST['sdk_android'];
    $sdk_ios = $_POST['sdk_ios'];

    $select2 = OA_Dal_Delivery_query("SELECT * from {$table_prefix}dj_admin_configuration");

    if (OA_Dal_Delivery_numRows($select2) > 0)
    {
        OA_Dal_Delivery_query("UPDATE {$table_prefix}dj_admin_configuration set SDK_Androidpath ='".$sdk_android."',SDK_IOSpath ='".$sdk_ios."'");
    }
    else
    {
        OA_Dal_Delivery_query("INSERT INTO {$table_prefix}dj_admin_configuration(SDK_Androidpath,SDK_IOSpath)VALUES('".$sdk_android."','".$sdk_ios."')");
    }
}


$select = OA_Dal_Delivery_query("SELECT * from {$table_prefix}dj_admin_configuration");
$row = OA_Dal_Delivery_fetchAssoc($select);

$djax_mobileappandroid = '';
$djax_mobileappios = '';

$djax_mobileappandroid = array(
    'text' => 'Mobile app android ',
    'items' => array(
        array(
            'type' => 'text',
            'name' => 'sdk_android',
            'text' => 'Mobile android SDK',
            'size' => 50,
            'value' => $row['sdk_androidpath']

        ) ,
        array(
            'type' => 'break'

        )

    )
);

$djax_mobileappios = array(
    'text' => 'Mobile app IOS ',
    'items' => array(
        array(
            'type' => 'text',
            'name' => 'sdk_ios',
            'text' => 'Mobile  IOS',
            'size' => 50,
            'value' => $row['sdk_iospath']
        ) ,
        array(
            'type' => 'break'
        )

    )
);

$aSettings = array(
    $djax_mobileappandroid,
    $djax_mobileappios
);

$oOptions->show($aSettings);

phpAds_PageFooter();

?>
