<?php
// Require the initialisation file
$path = dirname(__FILE__);
require_once '../../../../init.php';

// Required files
require_once MAX_PATH . '/www/admin/lib-maintenance-priority.inc.php';
require_once MAX_PATH . '/lib/OA/Dal.php';
require_once MAX_PATH . '/lib/OA/Dll.php';
require_once MAX_PATH . '/www/admin/config.php';
require_once MAX_PATH . '/www/admin/lib-statistics.inc.php';
require_once MAX_PATH . '/lib/OX/Admin/Redirect.php';
require_once MAX_PATH . '/lib/OA/Admin/Option.php';
require_once MAX_PATH . '/lib/OA/Admin/Settings.php';
require_once MAX_PATH . '/lib/max/Plugin/Translation.php';
require_once MAX_PATH . '/lib/OX/Plugin/Component.php';

 if($GLOBALS['_MAX']['CONF']['database']['type']=='mysql')
{
require_once MAX_PATH . '/lib/OA/Dal/Delivery/mysql.php';
}
else if($GLOBALS['_MAX']['CONF']['database']['type']=='pgsql')
{
require_once MAX_PATH . '/lib/OA/Dal/Delivery/pgsql.php';
}
else if($GLOBALS['_MAX']['CONF']['database']['type']=='mysqli')
{
require_once MAX_PATH . '/lib/OA/Dal/Delivery/mysqli.php';
}
	$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];

// Security check
OA_Permission::enforceAccount(OA_ACCOUNT_TRAFFICKER, OA_ACCOUNT_MANAGER);
OA_Permission::enforceAccessToObject('affiliates', $affiliateid);
OA_Permission::enforceAccessToObject('zones', $zoneid, true);

$oTranslation = new OX_Translation();

// Create a new option object for displaying the setting's page's HTML form
$oOptions = new OA_Admin_Option('manage_segments');
$prefSection = "Add Segment";

$setPref = $oOptions->getSettingsPreferences($prefSection);
$title = $setPref[$prefSection]['name'];

$aErrormessage = array();

// Display the settings page's header and sections
$oHeaderModel = new OA_Admin_UI_Model_PageHeaderModel("Add Segment");
phpAds_PageHeader('manage_segments',$oHeaderModel);

$account_id =OA_Dal_Delivery_fetchAssoc(OA_Dal_Delivery_query("SELECT account_id FROM {$table_prefix}affiliates WHERE affiliateid='".$_GET['affiliateid']."'"));

$sel_segrow=OA_Dal_Delivery_fetchAssoc(OA_Dal_Delivery_query("SELECT seg_name,seg_net,seg_geo,seg_platform,seg_apps,seg_format FROM mediation_segments WHERE id='".$_GET['id']."'"));

if($_POST['submit']=='Save Changes')
{
//~ print_r($_POST);exit;
	$seg_geo=implode(",",$_POST['seg_countries']); 

	$seg_app=implode(",",$_POST['apps_list']); 
					
	$seg_net=implode(",",$_POST['networks_list']); 
					
	$seg_plat=implode(",",$_POST['platforms_list']); 
					
	$seg_for=implode(",",$_POST['formats_list']); 	
				 		
	if($_GET['mode'] == 'add')
	{	
		OA_Dal_Delivery_query("INSERT INTO mediation_segments(account_id, seg_name,seg_net,seg_geo,seg_platform,seg_apps, 	seg_format,ecpm,status,seg_type,is_default_seg) VALUES('".$account_id['account_id']."','".$_POST['seg_name']."','".$seg_net."','".$seg_geo."','".$seg_plat."','".$seg_app."','".$seg_for."','0.500000','1','1','0')");
			
		$last_insertid = OA_Dal_Delivery_insertId();
			
		$SQl .= "SELECT * from mediation_net_zone_assoc as za 
		JOIN mediation_app_adunit_details as ad
		ON za.zone_id=ad.adunit_id 
		JOIN mediation_app_detail as ma
		ON ad.app_id=ma.appid 
		JOIN mediation_add_network  as an 
		ON an.network_id=za.network_id
		AND an.account_id ='".$account_id['account_id']."' 
		WHERE 1 
		AND ad.is_deleted=0 
		AND ma.is_deleted=0 
		AND za.account_id='".$account_id['account_id']."'";
		
		if($seg_net != 'all')
		{
			$SQl .= " AND an.network_id IN (".$seg_net.")";
		}
		if($seg_plat != 'all')
		{
			$SQl .= " AND ma.platform_type IN (".$seg_plat.")";
		}
		if($seg_app != 'all')
		{
			$SQl .= " AND ma.appid IN (".$seg_app.")";
		}
		if($seg_for != 'all')
		{
			$SQl .= " AND ad.ad_format IN (".$seg_for.")";
		}
		if($seg_geo != 'all')
		{
			$se_geo = implode("|",$_POST['seg_countries']);
			$SQl .= " AND CONCAT(',',an.country_target, ',') REGEXP ',(".$se_geo."),'";
		}
		$SQl .= " GROUP BY zone_id,an.network_id,ad.app_id";
	
		$query = OA_Dal_Delivery_query($SQl);

		if(OA_Dal_Delivery_numRows($query)>0)
		{
			while($segassoc=OA_Dal_Delivery_fetchAssoc($query))
			{
				$adm_cpm=OA_Dal_Delivery_fetchAssoc(OA_DAL_Delivery_query("select config_value from mediation_markplace_config where config_id='1'"));
				
				OA_DAL_Delivery_query("INSERT INTO mediation_segment_assoc(account_id, segment_id,app_id,adunit_id,network_id,ecpm,status) VALUES('".$account_id['account_id']."','".$last_insertid."','".$segassoc['appid']."','".$segassoc['adunit_id']."','".$segassoc['network_id']."','".$adm_cpm['config_value']."','1')");
			}
		}
		$translation = new OX_Translation ();
		$translated_message = $translation->translate ('Segment has been added successfully.');
		OA_Admin_UI::queueMessage($translated_message, 'local', 'confirm', 0);
		?>
		<script type="text/javascript">
		window.location.replace("manage_segments.php?affiliateid=<?php echo $_GET['affiliateid'];?>");
		</script><?php
	}else
	{	
		
		if($_POST['hide'] == '1')
		{
			
			OA_Dal_Delivery_query("DELETE FROM mediation_segment_assoc WHERE segment_id='".$_GET['id']."'");

			OA_Dal_Delivery_query("UPDATE `mediation_segments` SET `seg_name`='".$_POST['seg_name']."',seg_geo='".$seg_geo."',`seg_net`='".$seg_net."',`seg_platform`='".$seg_plat."',`seg_apps`='".$seg_app."',`seg_format`='".$seg_for."' WHERE `id`='".$_GET['id']."'");
			
			$SQl .= "SELECT * FROM 				mediation_net_zone_assoc as za 
			JOIN mediation_app_adunit_details as ad
			ON za.zone_id=ad.adunit_id 
			JOIN mediation_app_detail as ma
			ON ad.app_id=ma.appid 
			JOIN mediation_add_network  as an 
			ON an.network_id=za.network_id
			AND an.account_id ='".$account_id['account_id']."' 
			WHERE 1 
			AND ad.is_deleted=0 
			AND ma.is_deleted=0 
			AND za.account_id='".$account_id['account_id']."'";
				
			if($seg_net != 'all')
			{
				$SQl .= " AND an.network_id IN (".$seg_net.")";
			}
			if($seg_plat != 'all')
			{
				$SQl .= " AND ma.platform_type IN (".$seg_plat.")";
			}
			if($seg_app != 'all')
			{
				$SQl .= " AND ma.appid IN (".$seg_app.")";
			}
			if($seg_for != 'all')
			{
				$SQl .= " AND ad.ad_format IN (".$seg_for.")";
			}			
			if($seg_geo != 'all')
			{
				$se_geo = implode("|",$_POST['seg_countries']);
				$SQl .= " AND  IF(an.country_target != 'all' , CONCAT(',',an.country_target, ',') REGEXP ',(".$se_geo."),' ,'1')";
				
			}
			$SQl .= " GROUP BY zone_id,an.network_id,ad.app_id";

			$query = OA_Dal_Delivery_query($SQl);
				
			if(OA_Dal_Delivery_numRows($query)>0)
			{
				while($segassoc=OA_Dal_Delivery_fetchAssoc($query))
				{
					OA_DAL_Delivery_query("INSERT INTO mediation_segment_assoc(account_id, segment_id,app_id,adunit_id,network_id,status) VALUES('".$account_id['account_id']."','".$_GET['id']."','".$segassoc['appid']."','".$segassoc['adunit_id']."','".$segassoc['network_id']."','1')");
				}
			}
			$translation = new OX_Translation ();
			$translated_message = $translation->translate ('Segment has been updated successfully.');
			OA_Admin_UI::queueMessage($translated_message, 'local', 'confirm', 0);
			?>
			<script type="text/javascript">
			window.location.replace("manage_segments.php?affiliateid=<?php echo $_GET['affiliateid'];?>");
			</script><?php
		}
		if($_POST['hide'] == '2')
		{
			if($_POST['seg_name'] != $sel_segrow['seg_name'])
			{
				OA_Dal_Delivery_query("UPDATE `mediation_segments` SET `seg_name`='".$_POST['seg_name']."' WHERE `id`='".$_GET['id']."'");
											
				$translation = new OX_Translation ();
				$translated_message = $translation->translate ('Segment name updated successfully.');
				OA_Admin_UI::queueMessage($translated_message, 'local', 'confirm', 0);
				?>
				
				<script type="text/javascript">
				window.location.replace("manage_segments.php?affiliateid=<?php echo $_GET['affiliateid'];?>");
				</script><?php
			}else
			{
				$translation = new OX_Translation ();
				$translated_message = $translation->translate ('Segment not updated.');
				OA_Admin_UI::queueMessage($translated_message, 'local', 'confirm', 0);
				?>
				
				<script type="text/javascript">
				window.location.replace("manage_segments.php?affiliateid=<?php echo $_GET['affiliateid'];?>");
				</script><?php	
				
				
			}
		}
	}
}
?>

<html>
<head>
	
<!--
	<link rel='stylesheet' href='https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css'>
-->
	<script src="assets/js/jquery.min.js"></script>	
	<script src="assets/js/select2.min.js"></script>
	<link rel="stylesheet" href="assets/css/select2.css">

<style type="text/css">

	body{
			font-size: 11px;
		}
	div.breadcrumb h3 span.label{
			font-size : 20px;
		}
	.label{
			color: #444;
			font-weight: bold;
			height: 23px;
			line-height: 23px;
			font-size: 11px;
		}		
				
</style>


</head>
<body>
	<form  action='' method='post' name='addsegmentform' id='addsegmentform' class='add-segments-form' enctype='multipart/form-data'>
		<table width="70%">	
			<tr>
			<td>Name</td>
			<td>
			<input required value="<?php echo $sel_segrow['seg_name']; ?>" type="text" id="segmentname" name="seg_name" >
			
			</td>
			
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>				
			<tr>
				<td>Geo</td>
				<td>
					 
					<select class="js-example-basic-multiple" multiple="multiple" id='seg_countries' name='seg_countries[]' style="width:300px;" >

						<option value="all" <?php echo $sel_segrow=='' || $sel_segrow['seg_geo']=='all' ? 'selected' : "" ?> >All Country</option>

						<?php 
						$country=OA_Dal_Delivery_query("select name,value from mediation_conf_targ_country order by name");
						$selectedCountries = explode(',', $sel_segrow['seg_geo']);							
							while($country_row=OA_Dal_Delivery_fetchAssoc($country))
						{
							$select = in_array($country_row['value'], $selectedCountries) ? 'selected' : '';
							
							echo '<option '.$select.' value="'.$country_row['value'].'">'.$country_row['name'].'</option>';
						}
						?></select>
				</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td>Apps</td>
				<td>
					 
					<select class="js-example-basic-multiple" multiple="multiple" id='apps_list' name='apps_list[]' style="width:300px;" >
						<option value="all" <?php echo $sel_segrow=='' || $sel_segrow['seg_apps']=='all' ? 'selected' : "" ?> >All Apps</option>
						<?php 

						$apps=OA_Dal_Delivery_query("SELECT ap.app_name,ap.account_id,ap.appid,ap.platform_type,ap.icon_image ,(select count(ad.adunit_id) FROM mediation_app_adunit_details as ad where ap.appid=ad.app_id AND ad.is_deleted=0) as adunitcount FROM mediation_app_detail as ap WHERE ap.is_deleted=0 AND ap.account_id ='".$account_id['account_id']."' ORDER BY ap.app_added_date ");
						
						$selectedapps = explode(',', $sel_segrow['seg_apps']);							
							while($apps_row=OA_Dal_Delivery_fetchAssoc($apps))
						{
							$select = in_array($apps_row['appid'], $selectedapps) ? 'selected' : '';
							echo '<option '.$select.' value="'.$apps_row['appid'].'">'.$apps_row['app_name'].'</option>';
						}
						?></select>
				</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td>Networks</td>
				<td>
					 
					<select class="js-example-basic-multiple" multiple="multiple" id='networks_list' name='networks_list[]' style="width:300px;" >
						<option value="all" <?php echo $sel_segrow=='' || $sel_segrow['seg_net']=='all' ? 'selected' : "" ?> >All Networks</option>
						<?php 
						$nets=OA_Dal_Delivery_query("select network_name,network_id from mediation_add_network where account_id='".$account_id['account_id']."'order by network_name");
						
						$selectednetworks = explode(',', $sel_segrow['seg_net']);							
							while($nets_row=OA_Dal_Delivery_fetchAssoc($nets))
						{
							$select = in_array($nets_row['network_id'], $selectednetworks) ? 'selected' : '';
							
							echo '<option '.$select.' value="'.$nets_row['network_id'].'">'.$nets_row['network_name'].'</option>';
						}
						?></select>
				</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td>Platforms</td>
				<td>						 
					<select class="js-example-basic-multiple" multiple="multiple" id='platforms_list' name='platforms_list[]' style="width:300px;" >
						<option value="all"  <?php echo $sel_segrow=='' || $sel_segrow['seg_platform']=='all' ? 'selected' : "" ?> >All Platforms</option>
						<option <?php if ($sel_segrow['seg_platform'] == '1' ||$sel_segrow['seg_platform'] == '1,0' || $sel_segrow['seg_platform'] == '0,1') echo 'selected' ; ?> value="1">Andriod</option>
						<option <?php if ($sel_segrow['seg_platform'] == '0' || $sel_segrow['seg_platform'] == '1,0' ||$sel_segrow['seg_platform'] == '0,1' ) echo 'selected' ; ?> value="0">iOS</option></select>
				</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td>Formats</td>
				<td>
					 
					<select class="js-example-basic-multiple" multiple="multiple" id='formats_list' name='formats_list[]' style="width:300px;" >
						<option value="all" <?php echo $sel_segrow=='' || $sel_segrow['seg_format']=='all' ? 'selected' : "" ?> >All Formats</option>
						<?php
							$selectedformats = explode(',', $sel_segrow['seg_format']);
						?>
						<option value="0" <?php echo $ba = in_array("0", $selectedformats) ? 'selected="selected"' : ''; ?>>Banner</option>
						<option value="1" <?php echo $me = in_array("1", $selectedformats) ? 'selected="selected"' : ''; ?>>Medium</option>
						<option value="2" <?php echo $fu = in_array("2", $selectedformats) ? 'selected="selected"' : ''; ?>>Full Screen</option>
						<option value="3" <?php echo $na = in_array("3", $selectedformats) ? 'selected="selected"' : ''; ?>>Native</option>
						<option value="4" <?php echo $re = in_array("4", $selectedformats) ? 'selected="selected"' : '';?>>Rewarded</option>
						<option value="5" <?php echo $cu = in_array("5", $selectedformats) ? 'selected="selected"' : ''; ?>>Custom</option>
						<option value="6" <?php echo $le = in_array("6", $selectedformats) ? 'selected="selected"' : '';?>>Leaderboard</option>
						<option value="7" <?php echo $sk = in_array("7", $selectedformats) ? 'selected="selected"' : '';?>>Skyscraper</option>
						</select>
					</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td>&nbsp;</td>
			</tr>
			<tr>
				
				<td>
					<input type="hidden" value="" name="hide" id="hide">
					<input type="submit" value="Save Changes" name="submit"onclick="clickAlert()"></td>	
				
			</tr>	
		</table>
</form>
</body>
</html>


<script type="text/javascript">
	var jq= $.noConflict(true);	
<?php if($_GET['mode'] == 'edit'){?>	
function clickAlert() {
     var alert = confirm("Notice!\nChanging the limitaion will unlink previously linked networks and new networks will linked .");
	
	if (alert == true) {
		document.getElementById('hide').value = 1;
	} else {
		document.getElementById('hide').value = 2;
	}

}
<?php  }?>

jq(document).ready(function()
	{
		
		jq("#seg_countries").select2();
		jq("#apps_list").select2();
		jq("#networks_list").select2();
		jq("#platforms_list").select2();
		jq("#formats_list").select2();
		
		preselected = ['all'];
		jq('#seg_countries').on("click", function(e) {
			var selected_element = jq(e.currentTarget);
			var select_val = selected_element.val();
			selected = jq(this).val();
			
			var difference = [];
			jq.grep(selected, function(el) {
				if (jq.inArray(el, preselected) == -1) difference.push(el);
			});
			
			if((difference == 'all')) {
				jq(this).val('all');
				jq('#seg_countries option[value="all"]').attr("selected","selected");
				jq(this).trigger('change');
				preselected = ['all'];
			} else {
				$("#seg_countries option:first").removeAttr('selected');
				jq(this).trigger('change');				 
				preselected = jq(this).val();
			}
			if(selected==null || selected.length == 0)
			{
				jq('#seg_countries').val('all');
				jq('#seg_countries option[value="all"]').attr("selected","selected");
				jq("#seg_countries").trigger('change');
			}
				
		});
		
		jq('#apps_list').on("click", function(e) {
			var selected_element = jq(e.currentTarget);
			var select_val = selected_element.val();
			selected = jq(this).val();
			
			var difference = [];
			jq.grep(selected, function(el) {
				if (jq.inArray(el, preselected) == -1) difference.push(el);
			});
			
			if((difference == 'all')) {
				jq(this).val('all');
				jq('#apps_list option[value="all"]').attr("selected","selected");
				jq(this).trigger('change');
				preselected = ['all'];
			} else {				
				$("#apps_list option:first").removeAttr('selected');
				jq(this).trigger('change');
				preselected = jq(this).val();
			}
			if(selected==null || selected.length == 0)
			{
				jq('#apps_list').val('all');
				jq('#apps_list option[value="all"]').attr("selected","selected");
				jq('#apps_list').trigger('change');
			}	
		});
		
		jq('#networks_list').on("click", function(e) {
			var selected_element = jq(e.currentTarget);
			var select_val = selected_element.val();
			selected = jq(this).val();
			
			var difference = [];
			jq.grep(selected, function(el) {
				if (jq.inArray(el, preselected) == -1) difference.push(el);
			});
			
			if((difference == 'all')) {
				jq(this).val('all');
				jq('#networks_list option[value="all"]').attr("selected","selected");
				jq(this).trigger('change');
				preselected = ['all'];
			} else {				
				$("#networks_list option:first").removeAttr('selected');
				jq(this).trigger('change'); 
				preselected = jq(this).val();
			}
			if(selected==null || selected.length == 0)
			{
				jq('#networks_list').val('all');
				jq('#networks_list option[value="all"]').attr("selected","selected");
				jq('#networks_list').trigger('change');
			}	
		});
		jq('#platforms_list').on("click", function(e) {
			var selected_element = jq(e.currentTarget);
			var select_val = selected_element.val();
			selected = jq(this).val();
			
			var difference = [];
			jq.grep(selected, function(el) {
				if (jq.inArray(el, preselected) == -1) difference.push(el);
			});
			
			if((difference == 'all')) {
				jq(this).val('all');
				jq('#platforms_list option[value="all"]').attr("selected","selected");
				jq(this).trigger('change');
				preselected = ['all'];
			} else {
				$("#platforms_list option:first").removeAttr('selected');
				jq(this).trigger('change'); 
				preselected = jq(this).val();
			}
			if(selected==null || selected.length == 0)
			{
				jq('#platforms_list').val('all');
				jq('#platforms_list option[value="all"]').attr("selected","selected");
				jq('#platforms_list').trigger('change');
			}	
		});
		jq('#formats_list').on("click", function(e) {
			var selected_element = jq(e.currentTarget);
			var select_val = selected_element.val();
			selected = jq(this).val();
			
			var difference = [];
			jq.grep(selected, function(el) {
				if (jq.inArray(el, preselected) == -1) difference.push(el);
			});
			
			if((difference == 'all')) {
				jq(this).val('all');
				jq('#formats_list option[value="all"]').attr("selected","selected");
				jq(this).trigger('change');
				preselected = ['all'];
			} else {
				
				$("#formats_list option:first").removeAttr('selected');
				jq(this).trigger('change'); 
				preselected = jq(this).val();
			}
			if(selected==null || selected.length == 0)
			{
				jq('#formats_list').val('all');
				jq('#formats_list option[value="all"]').attr("selected","selected");
				jq('#formats_list').trigger('change');
			}	
		});
	});
</script>


<?php

phpAds_PageFooter();

?>
