<?php

$path = dirname(__FILE__);
require_once '../../../../init.php';

// Required files
require_once MAX_PATH.'/www/admin/lib-maintenance-priority.inc.php';
require_once MAX_PATH.'/lib/OA/Dal.php';
require_once MAX_PATH.'/lib/OA/Dll.php';
require_once MAX_PATH.'/www/admin/config.php';
require_once MAX_PATH.'/www/admin/lib-statistics.inc.php';
require_once MAX_PATH.'/lib/OX/Admin/Redirect.php';

if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'pgsql')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/pgsql.php';
}
else if ($GLOBALS['_MAX']['CONF']['database']['type'] == 'mysqli')
{
    require_once MAX_PATH.'/lib/OA/Dal/Delivery/mysqli.php';
}
$account_id = $GLOBALS['session']['user']->aAccount['account_id'];

// Security check
OA_Permission::enforceAccount(OA_ACCOUNT_ADMIN);

$oHeaderModel = new OA_Admin_UI_Model_PageHeaderModel($title);
phpAds_PageHeader('manage_networks');

$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];

$paramlist = [];
if (!empty($_GET['networkid']))
{
    $query = (OA_Dal_Delivery_fetchAssoc(OA_Dal_Delivery_query("select network_name,network_id,tot_no_param from mediation_networks where network_id=".$_GET['networkid'])));

    $query_param = OA_Dal_Delivery_query("select parameter_name from mediation_networks_param where network_id=".$_GET['networkid']);

    while ($param_row = OA_Dal_Delivery_fetchAssoc($query_param))
    {
        $paramlist[] = $param_row['parameter_name'];
    }
}	

if (isset($_POST['addnet']))
{
	
    $querynumrow = OA_Dal_Delivery_query("select network_name from mediation_networks where network_name= '".$_POST['netname']."'");
    if (OA_Dal_Delivery_numRows($querynumrow) > 0)
    {
        $translation = new OX_Translation();
        $translated_message = $translation->translate('already exists this network.');
        OA_Admin_UI::queueMessage($translated_message, 'local', 'confirm', 0);
        echo '<script type="text/javascript">window.location.replace("admin_add_networks.php?mode=add");</script>';
        exit;
    }
    $tot_params = COUNT($_POST['textbox']);

    $query=OA_Dal_Delivery_query("INSERT into mediation_networks(account_id,network_name,status,tot_no_param,is_custom,is_default_net) VALUES('".$account_id."','".$_POST['netname']."','1','".$tot_params."','0','0')");


    // If insert was successful, get the last inserted ID
    $network_id = OA_Dal_Delivery_insertId('database', 'mediation_networks', 'network_id');

	
    $param_name = $_POST['textbox'];
    //inser param table
    foreach ($param_name as $key => $value)
    {
	
	
        OA_Dal_Delivery_query("INSERT into mediation_networks_param(network_id, parameter_name,Is_custom) VALUES('".$network_id."','".$value."','0')  ") or die("param insert");
    }

    $translation = new OX_Translation();
    $translated_message = $translation->translate('Network has been added successfully.');
    OA_Admin_UI::queueMessage($translated_message, 'local', 'confirm', 0);
    echo '<script type="text/javascript">window.location.replace("admin_networks.php");</script>';
}

if (isset($_POST['editnet']))
{
    $querynumrow = OA_Dal_Delivery_query("select network_name from mediation_networks where network_name='".$_POST['netname']."' and network_id!='".$_GET['networkid']."'");
    if (OA_Dal_Delivery_numRows($querynumrow) > 0)
    {
        $translation = new OX_Translation();
        $translated_message = $translation->translate('Already exists this network.');
        OA_Admin_UI::queueMessage($translated_message, 'local', 'confirm', 0);
        echo '<script type="text/javascript">window.location.replace("admin_add_networks.php?networkid='.$_GET['networkid'].'&mode=edit");</script>';
        exit;
    }

    $tot_params = COUNT($_POST['textbox']);
    $network_id = $_GET['networkid'];

    OA_Dal_Delivery_query("UPDATE mediation_networks set network_name='".$_POST['netname']."',tot_no_param='".$tot_params."' WHERE network_id='".$network_id."' ") or die("status already changed.");

    $param_name = $_POST['textbox'];
    //inser param table
    OA_Dal_Delivery_query("DELETE FROM mediation_networks_param WHERE network_id='".$network_id."'");
    foreach ($param_name as $key => $value)
    {
        OA_Dal_Delivery_query("INSERT into mediation_networks_param(network_id, parameter_name,Is_custom) VALUES('".$network_id."','".$value."','0')  ") or die("param insert");
    }

    $translation = new OX_Translation();
    $translated_message = $translation->translate('Network has been updated successfully.');
    OA_Admin_UI::queueMessage($translated_message, 'local', 'confirm', 0);
    echo '<script type="text/javascript">window.location.replace("admin_networks.php");</script>';
}

?>

<style type="text/css">
#TextBoxesGroup {
	padding: 8px;
}

#removeButton {
	margin-left: 20px;
	font-size: 15px;
	font-weight: bolder;
}

#txt {
	margin-left: -10px;
}

#addButton {
	margin-left: 20px;
	font-size: 15px;
	font-weight: bolder;
}

#ad {
	margin-bottom: 20px;
}

#save {
	margin-left: 82px;
}

.align {
	margin-left: 71px;
	margin-top: 8px;
}

.chk {
	margin-top: 15px;
}
</style>
<script type="text/javascript">
$(document).ready(function() {
	var counter = $("#paramlength").val();
	$("#addButton").click(function() {
		var newTextBoxDiv = $(document.createElement('div')).attr("id", 'TextBoxDiv' + counter);
		newTextBoxDiv.after().html('<label>Parameter Name:</label>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="text" class="chk" placeholder="Enter the parameter name" name="textbox[]' + counter + '" id="textbox' + counter + '" value="" required >&nbsp;<input type="button" value="x" id="removeButton" onClick="deleteparam1(this)">');
		newTextBoxDiv.appendTo("#TextBoxesGroup");
		counter++;
	});
	$("#removeButton").click(function() {
		//~ alert(counter);
		if(counter == 2) {
			return false;
		}
		counter--;
		$("#TextBoxDiv" + counter).remove();
	});
	$("#getButtonValue").click(function() {
		var msg = '';
		for(i = 1; i < counter; i++) {
			msg += "\n Textbox #" + i + " : " + $('#textbox' + i).val();
		}
		alert(msg);
	});
});

function deleteparam1(e) {
	if($('.chk').length == 1) {
		return false;
	} else {
		$(e).parent().remove();
	}
}
</script>

<?php if(isset($_GET['mode'])&&$_GET['mode']=='add') { ?>

	<form action='' method='post' name='addnetworkform'>
		<h3 id='ad'>Add Network</h3> &nbsp;&nbsp;&nbsp;
		<label>Network Name: </label>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
		<input type='textbox' name='netname' id='net' placeholder='Enter the network name' required>
		<input type='button' value='+' id='addButton'>
		<div id='TextBoxesGroup'>
			<div id="TextBoxDiv1">
				<label>Parameter Name:</label>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
				<input class="chk" type='textbox' id='textbox1' name='textbox[]' placeholder='Enter the parameter name' required>
				<input type='button' value='x' id='removeButton' onClick="deleteparam1(this)"> </div>
		</div>
		<input type="hidden" id='paramlength' value="2">
		<input type="submit" name='addnet' value="submit">
	</form>
<?php } if(isset($_GET['mode'])&&$_GET['mode']=='edit') { ?>
	<form  action='' method='post' name='addnetworkform' >
 

<h3 id='ad'>Add Network</h3>
&nbsp;&nbsp;&nbsp;<label>Network Name: </label>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type='textbox' value="<?php echo $query['network_name'] ;?>" name='netname' id='net' placeholder='Enter the network name' required>
		<input type='button' value='+' id='addButton'>		

<div id='TextBoxesGroup'>
	<?php 
			$limit = count($paramlist);
			
			if($limit>= 1){
				for($i=0;$i<$limit;$i++)
				{ ?>
					<div id="TextBoxDiv<?php echo $i+1;?>">
							<label>Parameter Name:</label>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="textbox" class="chk" id="textbox<?php echo $i+1;?>" placeholder="Enter the parameter name" name="textbox[]<?php echo $i;?>" value="<?php echo $paramlist[$i];?>" maxlength="50" required>&nbsp;<input type="button" value="x" id="removeButton" onClick="deleteparam1(this)"><br />
					</div>
						<?php 
				}
			} ?>
</div>
	<div>
		<input type="hidden" id='paramlength' value="<?php if($limit>= 1){echo $limit+1;}else{echo '2';}?>" >
		<input type="submit" name='editnet' value="submit"></td>
	</div>
	
</form>
<?php } 
phpAds_PageFooter();

?>
