<?php

/* 
+---------------------------------------------------------------------------+
| Revive Adserver                                                           |
| http://www.revive-adserver.com                                            |
|                                                                           |
| Copyright: See the COPYRIGHT.txt file.                                    |
| License: GPLv2 or later, see the LICENSE.txt file.                        |
+---------------------------------------------------------------------------+
*/


// Require the initialisation file
require_once '../../../../init.php';

// Required files
require_once MAX_PATH . '/lib/OA/Dal.php';
require_once MAX_PATH . '/www/admin/config.php';
require_once MAX_PATH . '/lib/max/other/html.php';
require_once MAX_PATH . '/lib/max/Admin_DA.php';

// Security check
OA_Permission::enforceAccount(OA_ACCOUNT_MANAGER, OA_ACCOUNT_TRAFFICKER);
OA_Permission::enforceAccessToObject('affiliates', $affiliateid);
OA_Permission::enforceAccessToObject('zones', $zoneid);

if (OA_Permission::isAccount(OA_ACCOUNT_TRAFFICKER)) {
    OA_Permission::enforceAllowed(OA_PERM_ZONE_INVOCATION);
}

/*-------------------------------------------------------*/
/* Store preferences									 */
/*-------------------------------------------------------*/
$session['prefs']['inventory_entities'][OA_Permission::getEntityId()]['affiliateid'] = $affiliateid;
phpAds_SessionDataStore();

/*-------------------------------------------------------*/
/* HTML framework                                        */
/*-------------------------------------------------------*/

// Initialise some parameters
$pageName = basename($_SERVER['SCRIPT_NAME']);
$tabIndex = 1;
$agencyId = OA_Permission::getAgencyId();
$aEntities = array('affiliateid' => $affiliateid, 'zoneid' => $zoneid);
$aOtherPublishers = Admin_DA::getPublishers(array('agency_id' => $agencyId));
$aOtherZones = Admin_DA::getZones(array('publisher_id' => $affiliateid));
MAX_displayNavigationZone($pageName, $aOtherPublishers, $aOtherZones, $aEntities);

/**  databse declaration - start **/

if($GLOBALS['_MAX']['CONF']['database']['type']=='pgsql'){
	require_once MAX_PATH . '/lib/OA/Dal/Delivery/pgsql.php';
} else if($GLOBALS['_MAX']['CONF']['database']['type']=='mysqli'){
	require_once MAX_PATH . '/lib/OA/Dal/Delivery/mysqli.php';
}

if ($GLOBALS['_MAX']['SSL_REQUEST']) 
{
	$djprotocol='https://';
}
else
{
	$djprotocol='http://';
}
$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];
$conf = $GLOBALS['_MAX']['CONF'];

/**  databse declaration - end **/

/*-------------------------------------------------------*/
/* Main code                                             */
/*-------------------------------------------------------*/
/** submit value into database  - start**/
if(isset($_POST['submit']))
{ 

	$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];
	$networks=$_POST['networks'];
	$details = [];
	$net_id = [];
    $net_details = serialize($networks);

	foreach($networks as $bname => $bvalue)
	{

		if(is_array($bvalue['value']))
		{
		  $net_id[] = $bname;
		}
		foreach($bvalue['value'] as $pname => $pvalue)
		{	
			
		
			
			if($_POST['networksname'])
			{		
				if(is_array($pvalue['value']))
				{
					foreach($pvalue['value'] as $sname => $svalue)
					{
					$details['networksname'][$bvalue['id']][$pvalue['name']][$svalue['name']] = $svalue['value'];
					}
				}
				else
				{	
				
				
					$details['networks'][$bvalue['name']] [$bvalue['id']] [$pname] = $pvalue;
			
					
					
				}
			}
			else
			{	
				
				if(is_array($pvalue['value']))
				{
					
					foreach($pvalue['value'] as $sname => $svalue)
					{
						$details['networksname'][$bvalue['id']][$pvalue['name']][$svalue['name']] = $svalue['value'];
					}
				}
				else
				{	
					
					$details['networksname'][$bvalue['id']][$pvalue['name']] = $pvalue;
			
				
				}
			}	
		}
	
		if(isset($_POST['networksname']))
		{
			 
			$networks[] = $networks[$bvalue[3]];
		
			$nets = serialize($networks);
		}
	}
	
	$is_update = $_POST['is_update'];
	if($is_update)
	{
		$zone_id = $_GET['zoneid'];

		OA_Dal_Delivery_query("DELETE FROM mediation_net_zone_paramater WHERE zone_id='{$zone_id}'");
	}
	foreach($details as $vale=>$val)

		{
			
			foreach($val as $a=>$b)
		    {
				$netname=$a;
				foreach($b as $name=>$value)
				{	
					$network_id=$name;
					foreach($value as $values=>$vale1)
					{
					$param_ids=$values;
						$param_name=$vale1['name'];
						$param_value=trim($vale1['value'],' ');
					
						
    $affiliateid = $_GET['affiliateid'];
	$zone_id = $_GET['zoneid'];

	$affiliates =OA_Dal_Delivery_fetchAssoc(OA_Dal_Delivery_query("SELECT * from {$table_prefix}affiliates where affiliateid='".$affiliateid."'"));
	$is_update = $_POST['is_update'];
	if($is_update)
	{
	$query = OA_Dal_Delivery_query("INSERT INTO mediation_net_zone_paramater(network_id,zone_id,parameter_id,parameter_value,account_id,networks,networks_details,network_name,parameter_name) VALUES ('{$network_id}','{$zone_id}','{$param_ids}','{$param_value}','{$affiliates['account_id']}','{$nets}','{$details}','{$netname}','{$param_name}')");
    }
	else
	{
	
	
		OA_Dal_Delivery_query("INSERT INTO mediation_net_zone_paramater(network_id,zone_id,parameter_id,parameter_value,account_id,networks,networks_details,network_name,parameter_name) VALUES ('{$network_id}','{$zone_id}','{$param_ids}','{$param_value}','{$affiliates['account_id']}','{$nets}','{$details}','{$netname}','{$param_name}')");
	}
					}

				}
			}
			
		}
		
	$details=serialize($details);


}
/** submit value into database  - end**/

?>
<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<link rel="stylesheet" href="assets/css/font-awesome.css">
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
<script src="https://cdn.jsdelivr.net/jquery.validation/1.16.0/jquery.validate.min.js"></script>
<script src="https://cdn.jsdelivr.net/jquery.validation/1.16.0/additional-methods.min.js"></script>

<style>
body{
	font-size: 11px;
}
div.breadcrumb h3 span.label{
	font-size : 20px;
}

#thirdLevelHeader div.breadcrumb{
	margin : 0px;
}

#settingsform1 .table td{
	font-size : 13px;
}
.expanded .label{
	color:black;
}

.container label{
	font-size: 12px;
	font-weight: normal;
}
.param_details{
	padding-left: 25px;
}

.subparam_details{
	padding-left: 50px;
}
.netname{
	width: 18%;
	font-weight: normal;
}
#submitButton{
	margin-left: 50px;
}
#chsubmitButton{
	text-align: center;
}
.param_details li input{
    border-radius: 5px;
    padding: 5px;
    border: 1px solid #ccc;
    margin-bottom: 5px;
}
.container
{
	margin-left: 0px;
}

</style>

<script>
var jq = $.noConflict(true);

function getparams(e)
{
	var netid = e.getAttribute('id');
	var affid = "<?php echo $affiliateid;?>";
	var class_name = e.getAttribute('class');
	
	if(e.checked == true){
	
		jq.ajax({
			
			type: "GET",
			
			url:"hbidajax.php",

			data:"netid="+netid+"&affid="+affid,
			
			dataType: 'json',

			success: function(data)
			{
			console.log("help",data);
				jq(".param_details_"+netid).parent().parent().remove();
				
				
				var param = '<div class="form-group '+class_name+' "><div class="col-sm-offset-3"><ul class="param_details param_details_'+netid+'">';
				
				jq.each(data, function(key, value) 
				{	
					var par=value.parameter_name;
					// var trimStr = $.trim(par);
					// console.log(trimStr);
					param  += '<li><div><label class="netname">'+value.parameter_name+'</label><input type="hidden"  name="networks['+netid+'][value]['+value.id+'][name]" value="'+value.parameter_name+'">';
					value.parareq = '1';
				if(value.parareq == '1')
				{
					param += '<input type="text" name="networks['+netid+'][value]['+value.id+'][value]" placeholder="'+value.parameter_name+'"  required>';
				}
				else
				{
					param += '<input type="text" name="networks['+netid+'][value]['+value.id+'][value]" value="'+value.parameter_name+'">';
				}
					
				});
				param +='</div></li></ul></div></div>';		
				jq("#outer_div_"+netid).after(param);

			}
		});
		
	}
	else
	{
		
		jq(".param_details_"+netid).parent().parent().remove();
		
	}
	console.log(".param_details_"+netid);
	if(jq(".param_details_"+netid).length > 0)
	{
		
	
		if(jq("#submitButton").length > 0){
	
			jq("#submitButton").attr('id','#chsubmitButton');
		}else{
			jq("#chsubmitButton").attr('id','#submitButton');
		}
	}
	
}


function allowDrop(ev) {
	ev.preventDefault();
	var x = ev.pageX,y = ev.pageY;
	var box=document.querySelectorAll("#container .rect>div ")	
  
	box.forEach(function(element) {
		
		element.style.backgroundColor=""
	})
	DADES.insBefore=false
	var div=document.querySelectorAll("#container .rect")
	 for (let element of div) {
	  if (element.offsetLeft >= x - DADES.insideX +  DADES.cantoX &&  element.offsetTop +  element.offsetHeight/2 >= y - DADES.insideY +  DADES.cantoY){
			if (element != DADES.target.nextSibling){
				element.firstElementChild.style.backgroundColor="lightblue"
				DADES.insBefore=element
			}else{
				DADES.insBefore="noInsert"
			}
			break
		}
	}
	DADES.target.firstElementChild.style.backgroundColor="lightblue"
 
}



function drag(ev) {
	
	
	var x = ev.pageX,y = ev.pageY;
  
	for (i in document.querySelectorAll("#container .rect")){
		if (document.querySelectorAll("#container .rect")[i]==ev.target)var index = i
	}
	DADES={ 
		cantoX : ev.target.offsetLeft , cantoY : ev.target.offsetTop ,
		insideX : ev.pageX, insideY : ev.pageY,
		target :ev.target,
		index:index
	}

  
	 ev.dataTransfer.setData("text", ev.target)   
}

function drop(ev) {
	ev.preventDefault()
	if (DADES.target != DADES.insBefore && DADES.insBefore!="noInsert"){	
	document.getElementById("container").style.height=document.getElementById("container").offsetHeight+"px"
			document.getElementById("container").removeChild(DADES.target);
			if (DADES.insBefore){		
				document.getElementById("container").insertBefore(DADES.target, DADES.insBefore)		
				DADES.target.setAttribute("style","width:0")
			}else{
				document.getElementById("container").appendChild(DADES.target)
			}
			
			setTimeout(()=>{DADES.target.setAttribute("style","transition:.1s");document.getElementById("container").style.height=""},01)
		
	}
	
	
}
function dragEnd(){

  var div=document.querySelectorAll("#container .rect>div ")

  div.forEach(function(element) {
		element.style.backgroundColor=""
	})
}



	
</script>

<?php

if(!empty($_GET['zoneid']))
{
$zone_id=$_GET['zoneid'];

	$exst_bid = OA_Dal_Delivery_query("SELECT * FROM mediation_net_zone_paramater WHERE  zone_id={$zone_id}");

if(!OA_Dal_Delivery_numRows($exst_bid))
{
	$affiliateid = $_GET['affiliateid'];
	$zoneid = $_GET['zoneid'];
	$get_bidderlist = OA_Dal_Delivery_fetchAssoc(OA_Dal_Delivery_query("SELECT is_mediation FROM {$table_prefix}affiliates  WHERE affiliateid = {$affiliateid}  "));
	if($get_bidderlist['is_mediation']==1)
	{
	?>
       <form method="POST" class="form-horizontal">		
	   <div class="form-group">
	   <label class="control-label col-sm-3" style="font-size: 14px;">Network details</label>
	   </div>
	   <div id="container"  ondrop="drop(event)" ondragover="allowDrop(event)" >
	   <?php
		$table_prefix = $GLOBALS['_MAX']['CONF']['table']['prefix'];
		$queryN = OA_Dal_Delivery_query("SELECT * FROM {$table_prefix}affiliates WHERE affiliateid =  ".$_GET['affiliateid']);    
		$Value = OA_Dal_Delivery_fetchAssoc($queryN);
		$net= unserialize($Value['comments']);
		$nworks=unserialize($net['network_id']);
		$ncount=count($nworks);
		$x=0;
		while($x <$ncount)
		{
			$Networks = OA_Dal_Delivery_query("SELECT * FROM mediation_networks WHERE network_id=".$nworks[$x]);
	        $num = OA_Dal_Delivery_numRows($Networks);
			if(!empty($num))
			{
				while($getcat = OA_Dal_Delivery_fetchAssoc($Networks))
				{
					$get_ele[][]=$getcat;
				}
			}
	
		foreach ($get_ele as $ab) 
		{
			foreach ($ab as $a=>$b)
			{
				$catchild = explode("-", $b['network_id']);
				$class = ($b['network_id'] == 0  && empty($catchild[1])) ? 'class="hd"' : '';
			    $space = ($b['network_id'] != 0 && !empty($catchild[1])) ? '' : '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'; 
			    $checked = "";
			    $networkid=$b['network_id'];
		        $selectedCat = unserialize($Value['comments']);
				$selectedCategory = unserialize($selectedCat['network_id']);
			} 
	    }
	    ?>
		
		<div class="rect" draggable="true" ondragstart="drag(event)" ondragend ="dragEnd()">
		<div class="form-group" id="outer_div_<?php echo $b['network_id'];?>">
		  <div class="col-sm-offset-2">		
		    <label class="control-label col-sm-12 select"  style="text-align:left;">					
						<!--this hidden used to get bidder name to store into database -->
		      <input type="checkbox" class="sel" id=<?php echo $networkid;?> name="networksname[]"  onclick = "getparams(this);">	
	   	      <?php echo $b['network_name']; ?> <br/>	
              <!--this hidden used to get network name to store into database -->
	          <input type="hidden" name="networks[<?php echo $b['network_id'];?>][name]" value='<?php echo $b["network_name"];?>'>
		      <!--this hidden used to get network code to store into database -->
		      <input type="hidden" name="networks[<?php echo $b['network_id'];?>][id]" value='<?php echo $b["network_id"];?>'>
            </label>
		  </div>
	    </div> 
	</div>
		<?php
		$x++;
		}	
		?>
		</div>
		<div class="form-group">        
		  <div class="col-sm-offset-2 col-sm-6" style="text-align: right;">
			<button type="submit" class="btn btn-default" name="submit">Save changes</button>
			<!-- store zone type -->
			<input type="hidden" name="zone_type" value="<?php echo $aOtherZones[$zoneid]['type'];?>">
		
		  </div>
		</div>	
	    </div>
       </form>
      <?php
    }

else{
	
	?>
		<div class="alert alert-warning">
			Currently no Networks avaliable for <strong><?php echo $aOtherPublishers[$affiliateid]['name'];?></strong>
		</div>
		<?php	
	}/**List networks which is choosed by publisher - end*/
}	

/** if already exist network value then list - start**/
else{
	$queryN = OA_Dal_Delivery_query("SELECT comments FROM {$table_prefix}affiliates WHERE affiliateid =  ".$_GET['affiliateid']);    
	$existing_biddingdetail = OA_Dal_Delivery_fetchAssoc($exst_bid);
	$bidders = unserialize($existing_biddingdetail['networks']);	
	$active_bidders = array();
	$active_bidders_key = array();
	$class_name = array();
	$i = 0;
	$bidder_details = OA_Dal_Delivery_fetchAssoc($queryN);
	$net= unserialize($bidder_details['comments']);
	$nworks=unserialize($net['network_id']);
	$ncount=count($nworks); 
	while($i<$ncount)
	{
		$active_bidders_keys[] = $nworks[$i];
		$Networks =OA_Dal_Delivery_fetchAssoc( OA_Dal_Delivery_query("SELECT * FROM mediation_networks WHERE network_id=".$nworks[$i]));
		$active_bidders[] = $Networks;
		$i++;
	}
	$exst_bidder_ids = array_keys($bidders);
	?>
	<div class="container">
	<p style="font-size: 17px;font-weight: bold;">Network settings</p>
	<hr/>
	<form method="POST" class="form-horizontal">	
		<div class="form-group">
			<label class="control-label col-sm-3" style="font-size: 14px;">Network details</label>
      </div>
	  <div id="container"  ondrop="drop(event)" ondragover="allowDrop(event)" >
	<?php
	/** List network details - start **/

	foreach($bidders as $bidname => $bidvalue)
	{
	/**check it was choosed (has params)**/
		if(in_array($bidname, $active_bidders_keys))
		{
		if(is_array($bidvalue['value'])){
			// print_r($bidvalue);
			?>
			<div class="rect" draggable="true" ondragstart="drag(event)" ondragend ="dragEnd()">
              <div class="form-group" id="outer_div_<?php echo $bidname;?>">
					<div class="col-sm-offset-2">					
						<label class="control-label col-sm-2 <?=$class_name?>" style="text-align:left;">						
							<input type="checkbox"  id=<?php echo $bidname;?> class="sel" name="networksname[]"  onclick = "getparams(this);" checked>					
						<?php echo $bidvalue['name'];?>
						<input type="hidden" name="networks[<?php echo $bidname;?>][name]" value='<?php echo $bidvalue["name"];?>'>
						<input type="hidden" name="networks[<?php echo $bidname;?>][id]" value='<?php echo $bidvalue["id"];?>'>
						</label>
					</div>
				</div>
		</div>
		<div class="rect" draggable="true" ondragstart="drag(event)" ondragend ="dragEnd()">
				<div class="form-group">
					<div class="col-sm-offset-3">
						<ul class="param_details param_details_<?php echo $bidname;?>">
				<?php
					
				/**list param details  - start**/
				foreach($bidvalue['value'] as $paramname => $paramvalue)
				{
				
				?>
				
				<li>
					<div class="<?=$class_name?>_params">
						<label class="netname" ><?php echo $paramvalue['name']?></label>
						<input type="hidden" name="networks[<?php echo $bidname;?>][value][<?php echo $paramname;?>][name]" value="<?php echo $paramvalue['name']?>" >
						<?php
										
						/** check it has subparameter or not**/
						if(is_array($paramvalue['value'])){
						
						?>
						<ul class="subparam_details param_details_<?php echo $paramname;?>">
						<?php
						/** list subparameter - start**/
							foreach($paramvalue['value'] as $subparamname => $subparamvalue){
						
						?>
							<li>
								<div>
									<label class="bidname"><?php echo $subparamvalue['name'];?></label>
									<input type="hidden" name="networks[<?php echo $bidname;?>][value][<?php echo $paramname;?>][value][<?php echo $subparamname;?>][name]" value="<?php echo $subparamvalue['name'];?>">
									<input type="text" name="networks[<?php echo $bidname;?>][value][<?php echo $paramname;?>][value][<?php echo $subparamname;?>][value]" value="<?php echo ($subparamvalue['value']=='null')? "":$subparamvalue['value'] ;?>">
								</div>
							</li>
						<?php	
							}
							/** list subparameter - end**/
						?>
						</ul>
						
						<?php	
						/** list parameter value **/
						}else{
							
						?>
					<?php
					$paramvalue['value']=trim($paramvalue['value'],' ');
					// print_r($paramvalue['value']);
					// exit;
		
					?>
						<input type="text" name="networks[<?php echo $bidname;?>][value][<?php echo $paramname;?>][value]" value="<?php echo ($paramvalue['value']=='null')?'':$paramvalue['value'];?> "required>
						<?php
					}
					?>
					</div>
				</li>
						
				<?php	
					}
					/** list parameter details -end**/
				?>
				</ul>
					</div>
				</div>
				</div>
				<?php
		}
		else{ 
			/** list unchecked network details - start **/
			?>
					<div class="rect" draggable="true" ondragstart="drag(event)" ondragend ="dragEnd()">
			<div class="form-group" id="outer_div_<?php echo $bidname;?>">
					<div class="col-sm-offset-2">					
						<label class="control-label col-sm-2 <?=$class_name?>" style="text-align:left;">						
							<input type="checkbox"  id=<?php echo $bidname;?> class="sel" name="networksname[]"  onclick = "getparams(this);">					
						<?php echo $bidvalue['name'];?>
						<input type="hidden" name="networks[<?php echo $bidname;?>][name]" value='<?php echo $bidvalue["name"];?>'>
						<input type="hidden" name="networks[<?php echo $bidname;?>][id]" value='<?php echo $bidvalue["id"];?>'>
						</label>
					</div>
				</div>
				</div>
			<?php
		}
		}

		/** list unchecked network details - end **/
	}

			foreach ($active_bidders as $key => $value) {
				if((!in_array($value["hb_bidder_id"], $exst_bidder_ids)) && $value['hb_bidder_name']!="" && $value['hb_bidder_name'] !=null)
				{
				
			?>
			<div class="rect" draggable="true" ondragstart="drag(event)" ondragend ="dragEnd()">
				<div class="form-group" id="bid_detail_<?php echo $value['hb_bidder_id'];?>">
					<div class="col-sm-offset-2">					
						<label class="control-label col-sm-6" style="text-align:left;">						
							<input type="checkbox" class="" name="bidder[<?php echo $value['hb_bidder_id'];?>]" data-bidder ="<?php echo $value['hb_bidder_id'];?>"  data-bidder-name ="<?php echo $value['hb_bidder_code'];?>" onclick = "getparams(this);">					
						<?php echo $value['hb_bidder_name'];?>
						<!--this hidden used to get network name to store into database -->
						<input type="hidden" name="bidder_detail[<?php echo $value['hb_bidder_id'];?>][name]" value='<?php echo $value["hb_bidder_name"];?>'>
						<!--this hidden used to get network id to store into database -->
						<input type="hidden" name="bidder_detail[<?php echo $value['hb_bidder_id'];?>][id]" value='<?php echo $value["hb_bidder_code"];?>'>
						</label>
					</div>
				</div>
				</div>
			<?php
				}
			}

	/** list network details - end **/	
	?>
	</div>
	<div class="form-group">        
		  <div class="col-sm-offset-2 col-sm-6" style="text-align: right;">
			<button type="submit" class="btn btn-default" name="submit">Save changes</button>
			<!-- store zone type -->
			<input type="hidden" name="zone_type" value="<?php echo $aOtherZones[$zoneid]['type'];?>">
			<input type="hidden" name="is_update" value='1'>
		  </div>
		</div>	
	<?php
}

/** if already exist network value then list - end**/

}

/*-------------------------------------------------------*/
/* HTML framework                                        */
/*-------------------------------------------------------*/

phpAds_PageFooter();

?>




